> ## Documentation Index
> Fetch the complete documentation index at: https://docs.upwell.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Many Customers

> Create multiple customers at once



## OpenAPI

````yaml /api-reference/openapi.json post /api/rest/bulk-customers
openapi: 3.1.0
info:
  description: >-
    Upwell is Accounts Receivable automation software for the logistics
    industry. We serve freight brokers, carriers, factors, and anyone who needs
    to get transportation invoices paid.


    Learn more at:


    - [Upwell.com](https://upwell.com)
  title: Upwell REST API
  version: 3.30.2
  termsOfService: https://upwell.com/legal
  contact:
    name: Upwell
    url: https://upwell.com
    email: contact@upwell.com
servers:
  - url: https://api.upwell.com
    description: Production server
  - url: https://staging.api.upwell.com
    description: Staging server
security: []
tags:
  - name: Invoice Approval
    description: Endpoints for managing customer invoice approval workflow
paths:
  /api/rest/bulk-customers:
    post:
      tags:
        - Customers
      summary: Create Many Customers
      description: Create multiple customers at once
      parameters:
        - description: >-
            Your API key will be used for authentication of the request.
            `Authorization: YOUR_API_KEY`
          in: header
          name: authorization
          schema:
            type: string
      requestBody:
        content:
          application/json:
            schema:
              properties:
                inputs:
                  items:
                    $ref: '#/components/schemas/CustomersInsertInput'
                  nullable: false
                  type: array
              type: object
        description: >-
          Query parameters can also be provided in the request body as a JSON
          object
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                properties:
                  createCustomers:
                    description: response of any mutation on the table "customers"
                    nullable: true
                    properties:
                      returning:
                        items:
                          description: columns and relationships of "customers"
                          nullable: false
                          properties:
                            addresses:
                              items:
                                description: columns and relationships of "addresses"
                                nullable: false
                                properties:
                                  city:
                                    nullable: true
                                    title: String
                                    type: string
                                  country:
                                    $ref: '#/components/schemas/CountryCodeEnum'
                                  id:
                                    nullable: false
                                    title: String
                                    type: string
                                  stateOrProvince:
                                    nullable: true
                                    title: String
                                    type: string
                                  streetLine1:
                                    nullable: true
                                    title: String
                                    type: string
                                  streetLine2:
                                    nullable: true
                                    title: String
                                    type: string
                                  type:
                                    $ref: '#/components/schemas/AddressTypeEnum'
                                  zipOrPostalCode:
                                    nullable: true
                                    title: String
                                    type: string
                                title: Addresses
                                type: object
                              nullable: false
                              type: array
                            balance:
                              $ref: '#/components/schemas/bigint'
                            billToCustomerId:
                              nullable: true
                              title: String
                              type: string
                            ccEmailAddresses:
                              items:
                                nullable: false
                                title: String
                                type: string
                              nullable: true
                              type: array
                            createdAt:
                              $ref: '#/components/schemas/timestamptz'
                            customerRule:
                              description: columns and relationships of "customer_rules"
                              nullable: true
                              properties:
                                dueOption:
                                  nullable: false
                                  title: Int
                                  type: integer
                                id:
                                  nullable: false
                                  title: String
                                  type: string
                              title: CustomerRules
                              type: object
                            emailAddress:
                              nullable: true
                              title: String
                              type: string
                            id:
                              nullable: false
                              title: String
                              type: string
                            metadata:
                              $ref: '#/components/schemas/jsonb'
                            name:
                              nullable: true
                              title: String
                              type: string
                            overdueBalance:
                              $ref: '#/components/schemas/bigint'
                            overdueInvoiceCount:
                              nullable: true
                              title: Int
                              type: integer
                            sourceSystem:
                              nullable: true
                              title: String
                              type: string
                            sourceSystemId:
                              nullable: true
                              title: String
                              type: string
                            updatedAt:
                              $ref: '#/components/schemas/timestamptz'
                          title: Customers
                          type: object
                        nullable: false
                        type: array
                    title: CustomersMutationResponse
                    type: object
          description: Responses for POST /api/rest/bulk-customers
components:
  schemas:
    CustomersInsertInput:
      description: input type for inserting data into table "customers"
      nullable: false
      properties:
        addresses:
          type: object
          description: AddressesArrRelInsertInput (simplified)
        addressesLastUpdatedAt:
          $ref: '#/components/schemas/timestamptz'
        billToCode:
          nullable: true
          title: String
          type: string
        billToCustomerId:
          nullable: true
          title: String
          type: string
        billToSource:
          nullable: true
          title: String
          type: string
        ccEmailAddresses:
          items:
            nullable: false
            title: String
            type: string
          nullable: true
          type: array
        childCustomers:
          type: object
          description: CustomersArrRelInsertInput (simplified)
        collectorId:
          $ref: '#/components/schemas/uuid'
        contacts:
          type: object
          description: ContactsArrRelInsertInput (simplified)
        contactsLastUpdatedAt:
          $ref: '#/components/schemas/timestamptz'
        customerEmailSettings:
          type: object
          description: CustomerEmailSettingsArrRelInsertInput (simplified)
        customerIntegrationSettings:
          type: object
          description: CustomerIntegrationSettingsArrRelInsertInput (simplified)
        customerRule:
          type: object
          description: CustomerRulesObjRelInsertInput (simplified)
        deletedAt:
          $ref: '#/components/schemas/timestamp'
        deliveryRoutingRules:
          type: object
          description: DeliveryRoutingRulesArrRelInsertInput (simplified)
        emailAddress:
          nullable: true
          title: String
          type: string
        invoiceSplitRules:
          type: object
          description: InvoiceSplitRulesArrRelInsertInput (simplified)
        isActive:
          nullable: true
          title: Boolean
          type: boolean
        mergedIntoCustomer:
          type: object
          description: CustomersObjRelInsertInput (simplified)
        mergedIntoCustomerId:
          nullable: true
          title: String
          type: string
        metadata:
          $ref: '#/components/schemas/jsonb'
        name:
          nullable: true
          title: String
          type: string
        paymentDiscountTerms:
          $ref: '#/components/schemas/jsonb'
        paymentLineItems:
          type: object
          description: PaymentLineItemsArrRelInsertInput (simplified)
        remittanceLineItems:
          type: object
          description: RemittanceLineItemsArrRelInsertInput (simplified)
        sourceSystem:
          nullable: true
          title: String
          type: string
        sourceSystemId:
          nullable: true
          title: String
          type: string
        statementSchedules:
          type: object
          description: StatementSchedulesArrRelInsertInput (simplified)
        tmsBalanceCents:
          $ref: '#/components/schemas/bigint'
        tmsCustomerType:
          nullable: true
          title: String
          type: string
      title: CustomersInsertInput
      type: object
    CountryCodeEnum:
      enum:
        - AD
        - AE
        - AF
        - AG
        - AL
        - AM
        - AO
        - AR
        - AT
        - AU
        - AZ
        - BA
        - BB
        - BD
        - BE
        - BF
        - BG
        - BH
        - BI
        - BJ
        - BN
        - BO
        - BR
        - BS
        - BT
        - BW
        - BY
        - BZ
        - CA
        - CD
        - CF
        - CG
        - CH
        - CI
        - CL
        - CM
        - CN
        - CO
        - CR
        - CU
        - CV
        - CY
        - CZ
        - DE
        - DJ
        - DK
        - DM
        - DO
        - DZ
        - EC
        - EE
        - EG
        - ER
        - ES
        - ET
        - FI
        - FJ
        - FM
        - FR
        - GA
        - GB
        - GD
        - GE
        - GH
        - GM
        - GN
        - GQ
        - GR
        - GT
        - GW
        - GY
        - HK
        - HN
        - HR
        - HT
        - HU
        - ID
        - IE
        - IL
        - IN
        - IQ
        - IR
        - IS
        - IT
        - JM
        - JO
        - JP
        - KE
        - KG
        - KH
        - KI
        - KM
        - KN
        - KP
        - KR
        - KW
        - KZ
        - LA
        - LB
        - LC
        - LI
        - LK
        - LR
        - LS
        - LT
        - LU
        - LV
        - LY
        - MA
        - MC
        - MD
        - ME
        - MG
        - MH
        - MK
        - ML
        - MM
        - MN
        - MO
        - MR
        - MT
        - MU
        - MV
        - MW
        - MX
        - MY
        - MZ
        - NA
        - NE
        - NG
        - NI
        - NL
        - 'NO'
        - NP
        - NR
        - NZ
        - OM
        - PA
        - PE
        - PG
        - PH
        - PK
        - PL
        - PR
        - PS
        - PT
        - PW
        - PY
        - QA
        - RO
        - RS
        - RU
        - RW
        - SA
        - SB
        - SC
        - SD
        - SE
        - SG
        - SI
        - SK
        - SL
        - SM
        - SN
        - SO
        - SR
        - SS
        - ST
        - SV
        - SY
        - SZ
        - TD
        - TG
        - TH
        - TJ
        - TL
        - TM
        - TN
        - TO
        - TR
        - TT
        - TV
        - TW
        - TZ
        - UA
        - UG
        - US
        - UY
        - UZ
        - VA
        - VC
        - VE
        - VN
        - VU
        - WS
        - YE
        - ZA
        - ZM
        - ZW
      nullable: false
      title: CountryCodeEnum
    AddressTypeEnum:
      enum:
        - ADDRESS_BOOK
        - CARRIER
        - CARRIER_BILLING
        - COMPANY_ADDRESS
        - CONTACT
        - CUSTOMER_BILLING
        - DELIVERY_RECEIPT
        - LUMPER_RECEIPT
        - SHIPMENT_CONSIGNEE
        - SHIPMENT_PICKUP
        - STOP
        - SUPPORTING_DOC_PARTY
      nullable: false
      title: AddressTypeEnum
    bigint:
      nullable: false
      title: bigint
    timestamptz:
      nullable: false
      title: timestamptz
      type: string
      format: date-time
      description: >-
        A timestamp with timezone in ISO 8601 format, such as
        2024-12-16T21:57:14.525733+00:00
    jsonb:
      nullable: false
      title: jsonb
    uuid:
      nullable: false
      pattern: '[a-f0-9]{8}-[a-f0-9]{4}-4[a-f0-9]{3}-[89aAbB][a-f0-9]{3}-[a-f0-9]{12}'
      title: uuid
      type: string
    timestamp:
      nullable: false
      title: timestamp

````